#ifndef UNICODE
#define UNICODE
#endif

//#include <windows.h>

#define PM_GETDICT  1001 //   
#define PM_SHOWLIST 1002 //   
#define PM_SHOWTRAN 1003 //   

typedef struct _AVL_NODE {
    int value;               //    
    struct _AVL_NODE* below; //       
    struct _AVL_NODE* above; //       
    int balance;             //    
} AVL_NODE, *PAVL_NODE;

typedef struct {
    AVL_NODE* root; //    
    AVL_NODE* next; //     
    int data;       //        !
    DWORD temp;     //  ( )
} AVL_TREE;   

typedef struct _BKRS_ENTRY { 
    struct _BKRS_ENTRY* next;   //  
    int start;                  //   
    int size;                   //   
} BKRS_ENTRY; 

typedef struct _BKRS_NODE { 
    AVL_NODE avl;    
    BKRS_ENTRY* entry;       //   
    struct _BKRS_NODE* next; //   
} BKRS_NODE;   

typedef struct { 
    BKRS_NODE* root; 
    BKRS_NODE* next;     
    int data;    
    int amax; //   
    int arts; //  
    int wrds; //  
    DWORD res3; 
    DWORD res4; 
} BKRS_TREE;

typedef struct {
    int flag;         // 
    int size;         //    
    HANDLE hdsl;      //   
    int index;        //    (BKRS_TREE) 
    TCHAR ndsl[1];
} DICT;

typedef struct { 
    DICT* dict;
    HANDLE hand;
    int start;
    int size;
} FOUND_ITEM;    

#define BKRS_TREE_data_size (sizeof.BKRS_NODE - sizeof.AVL_NODE) / 2 
#define DICT_LOADED 1
#define DICT_ACTIVE 2
#define DICT_ndsl sizeof.DICT 

typedef struct {
    int size;
    int vers;
    DICT* pa_dict; //  
    HWND* hMain; //     
    HWND* hStatus; //     
    HWND* phLast; //       
    HWND* phDict; //       ()
    HWND* phText; //        ()
    HWND* phTran; //      ()
    int* pcmd_block; // <>0 -  
    int* plist; // <>0 -  
    int* plist_handler; //       
    HWND* hList; //    
    int* ptran; // <>0 -   
    int* pignore_spaces; //  
    int* pxchar_c; //   
    int* pxchar_f; // -    
    int* pxchar_l; //   
    int* pxchar_d; //    
    int* pfull_text; //      . 
} DATA_CONTEXT;    


typedef struct { 
    int size;
    int vers; 
        //   -
    void (_stdcall *pavl_new_tree)(AVL_TREE* avl_tree, int _data); 
        // /   - 
    int (_stdcall *pavl_insert)
		(AVL_TREE* avl_tree, int pstart, int value); 
        //    -
    int (_stdcall *pavl_search)
		(AVL_TREE* avl_tree, int pstart, int value); 
        //    -
    int (_stdcall *pavl_enum)
      (AVL_TREE* avl_tree, int pstart,int (*_callbk)(), int _user); 
        // /   
    int (_stdcall *pindex_insert)
							(BKRS_TREE* bkrs_tree, TCHAR* pword); 
        //    
    int (_stdcall *pindex_search)
							(BKRS_TREE* bkrs_tree, TCHAR* pword); 
        //     
    void  (_stdcall *pindex_enum_words)
        (BKRS_TREE* bkrs_tree, 
         int WINAPI _callbk(int _user, TCHAR* buffer), int _user); 
        //  	
    DICT* (_stdcall *pdict_init)(TCHAR* _name); 
        //  
    void (_stdcall *pdict_remove)(DICT** pp_dict); 
        //  
    LPTHREAD_START_ROUTINE (_stdcall *pdict_reidx)();// (DICT** pp_dict);
        //    
    int (_stdcall *pdict_search)(DICT** pp_dict, TCHAR* _string); 
        //    
    void (_stdcall *pdict_combo)(HWND _combo); 
        //     
    int (_stdcall *pload_art_list)(DICT* _dict, int buffer); 
        //     
    void (_stdcall *ptermometer)(int part16);
        //       
    TCHAR* (_stdcall *pEditGetSel)(HWND _edit, TCHAR* buffer); 
        //   
    TCHAR* (_stdcall *pRTrim)(TCHAR* _buffer); 
        //    
    void (_stdcall *pRemoveTags)(TCHAR* _buffer); 
        //        
    void (_stdcall *pContinued)(TCHAR* _buffer); 
} FUNC_CONTEXT;

DATA_CONTEXT dxt;
FUNC_CONTEXT fxt;

void FullContextLoad(DATA_CONTEXT* pdata_context,
                     FUNC_CONTEXT* pfunc_context){
    memcpy(&dxt,pdata_context,pdata_context->size);
    memcpy(&fxt,pfunc_context,pfunc_context->size);

};